<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2019-11-13 16:37:02
 * @LastEditors: 无尘
 * @LastEditTime: 2019-12-17 20:18:25
 -->
<!--
<in-progress-active></in-progress-active>

import inProgressActive from '@/components/active/in-progress-active.vue';
-->

<template>
  <div v-if="inProgressData.length">
    <div class="separator-space">- 当前有计划中的活动，无法创建新的活动 -</div>
    <div class="in-progress-active border-box">
      <ul>
        <template v-for="(item, index) in inProgressData">
          <li
            :class="['border-box', selectItem == item.activityId && index != 0 ? 'li-border' : '']"
            :key="index + 'data'"
          >
            <div
              class="in-progress-active-title flex flex-space-between border-box"
              @click.stop.prevent="selectLi(item)"
            >
              <div class="active-title-left">
                <div class="active-title-name font-18 color-303133 font-w-700">{{ item.activityName }} <el-tag
                    v-if="item.status == 2"
                    type="danger"
                  >待完善</el-tag>
                  <el-tag
                    v-if="item.status == 1 && item.startDate > new Date().getTime()"
                    type="danger"
                  >未开始</el-tag>
                  <el-tag
                    v-if="item.status == 1 && item.startDate <= new Date().getTime()"
                    type="success"
                  >已开始</el-tag>
                </div>
                <div class="active-title-date font-14 color-909399 m-t-7">{{ item.startDate | formatTimeYmdHms }} - {{ item.endDate | formatTimeYmdHms }}</div>
              </div>
              <div class="active-title-right">
                <el-button
                  type="primary"
                  plain
                  @click.stop="toEdit(index, item)"
                >活动配置</el-button>
                <el-button
                  data-clipboard-action="copy"
                  :data-clipboard-text="item.activityUrl"
                  class="copy-tag"
                  type="primary"
                  plain
                  @click.stop="handleCopy(index, item)"
                >复制路径</el-button>
                <!--  -->

                <el-button
                  type="primary"
                  plain
                  @click.stop="toDataList(index, item)"
                >数据明细</el-button>
                <el-button
                  v-if="item.status == 2"
                  type="danger"
                  plain
                  @click="toDelList(index, item)"
                >删除</el-button>
              </div>
            </div>
            <div
              v-if="item.startDate <= new Date().getTime()"
              class="in-progress-active-body"
            >
              <out-date-active
                :barChartData="barChartData"
                :funnelData="funnelData"
                :activityId="item.activityId"
              ></out-date-active>
            </div>
          </li>
        </template>
      </ul>
    </div>
  </div>
</template>
<script>
import outDateActive from '@/components/active/out-date-active.vue';
import Clipboard from 'clipboard';
import { _debounce } from '@/common/js/public';
import showMsg from '@/common/js/showmsg';
import errMsg from '@/common/js/error';
import { getRequest } from '@/api/api';
export default {
  name: 'in-progress-active',
  components: {
    outDateActive
  },
  data() {
    return {
      funnelData: {},
      barChartData: {
        columns: ['日期', '新增参与人数', '新增受邀人数'],
        rows: []
      },
      selectItem: '',
      inProgressData: [
        {
          activityId: 1,
          activityName: '',
          startDate: '',
          endDate: '',
          activityUrl: ''
        }
      ]
    };
  },
  methods: {
    /**
     * 选择 li
     */
    selectLi(item) {
      const that = this;
      that.selectItem = item.activityId;
      that.getActivityData(item.activityId);
    },
    /**
     * 获取单个活动数据信息
     * /sharing-core-web/get-activity-data-summary
     */
    getActivityData(activityId) {
      const that = this;
      let para = {
        activityId: activityId
      };
      getRequest('/sharing-core-web/get-activity-data-summary', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            that.funnelData = resData.result || {};
            if (!!resData.result.trend && !!resData.result.trend.length) {
              resData.result.trend.forEach(ele => {
                ele['日期'] = ele.date.split('-')[2];
                ele['新增参与人数'] = ele.inviteCount;
                ele['新增受邀人数'] = ele.invitedCount;
              });
            }
            that.barChartData = {
              columns: ['日期', '新增参与人数', '新增受邀人数'],
              rows: resData.result.trend || []
            };
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    /**
     * 活动配置
     */
    toEdit(index, row) {
      const that = this;
      that.$router.push(`/createActive?activityId=${row.activityId}`);
    },
    /**
     * 数据明细
     */
    toDataList(index, row) {
      const that = this;
      that.$router.push(`/dataDetail?activityId=${row.activityId}`);
    },
    /**
     * 复制路径
     */
    /* eslint-disable */
    handleCopy: _debounce(function(index, row) {
      const that = this;
      const fakeElement = document.createElement('button');
      let clipboard = new Clipboard(fakeElement, {
        text: function() {
          return row.activityUrl || '您复制的数据是空的！';
        }
      });
      clipboard.on('success', e => {
        showMsg.showmsg('复制成功!', 'success');
        // 释放内存
        clipboard.destroy();
      });
      clipboard.on('error', e => {
        // 不支持复制
        showMsg.showmsg('该浏览器不支持自动复制!', 'warning');
        // 释放内存
        clipboard.destroy();
      });
      document.body.appendChild(fakeElement);
      fakeElement.click();
      document.body.removeChild(fakeElement);
    }, 300),
    /**
     * 删除
     */
    toDelList(index, item) {
      const that = this;
      this.$confirm('是否要删除该活动?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(() => {
          that.delData(item.activityId);
        })
        .catch(() => {});
    },
    delData(activityId) {
      const that = this;
      let para = {
        activityId: activityId
      };
      getRequest('/sharing-core-web/delete-activity', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            showMsg.showmsg('删除成功', 'success');
            that.currentPage = 1;
            that.getTableList();
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    /**
     * 获取列表数据
     */
    getTableList() {
      const that = this;
      let para = { type: 4 };
      getRequest('/sharing-core-web/page-activity', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            /*const nowDate = new Date().getTime();
             let arr = [];
            if (resData.result.result && resData.result.result.length) {
              resData.result.result.forEach(ele => {
                if (ele.endDate > nowDate) {
                  arr.push(ele);
                }
              });
            } */
            that.inProgressData = resData.result.result || [];
            if (resData.result.result.length) {
              that.getActivityData(resData.result.result[0].activityId);
            }
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    }
  },
  mounted() {
    const that = this;
    that.getTableList();
  }
};
</script>
<style lang="less" scoped>
.m-t-7 {
  margin-top: 7px;
}
.separator-space {
  width: 100%;
  height: 60px;
  line-height: 60px;
  text-align: center;
  font-size: 14px;
  color: #909399;
  font-weight: 600;
  &.no-active {
    height: 40px;
    line-height: 20px;
  }
}
.in-progress-active {
  width: 100%;
  padding: 0 20px 48px 20px;
  background: #fff;
  .el-tag {
    /* background-color: transparent;
    border-color: transparent;
    color: #f56c6c; */
    height: 25px;
    line-height: 25px;
    padding: 0 5px;
  }
  li {
    // height: 90px;
    padding: 0 20px;
    cursor: pointer;
    &.li-border {
      padding: 0 20px;
      box-shadow: 0px 0px 8px 3px rgba(154, 170, 201, 0.11);
      border-radius: 4px;
      border: 1px solid rgba(220, 223, 230, 1);
      margin-top: -1px;
    }
    .in-progress-active-title {
      padding: 20px 0;
      border-bottom: 1px solid #dcdfe6;
    }
    .in-progress-active-body {
      padding: 20px 0;
    }
  }
}
</style>
